Open CASCADE Technology: TopOpeBRepBuild_ShapeSet Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Protected Member Functions | Protected Attributes
TopOpeBRepBuild_ShapeSet Class Reference

Auxiliary class providing an exploration of a set of shapes to build faces or solids. To build faces : shapes are wires, elements are edges. To build solids : shapes are shells, elements are faces. The ShapeSet stores a list of shapes, a list of elements to start reconstructions, and a map to search neighbours. The map stores the connection between elements through subshapes of type <SubShapeType> given in constructor. <SubShapeType> is : More...

`#include <TopOpeBRepBuild_ShapeSet.hxx>`

Inheritance diagram for TopOpeBRepBuild_ShapeSet:
[legend]

## Public Member Functions
| TopOpeBRepBuild_ShapeSet (const TopAbs_ShapeEnum SubShapeType, const Standard_Boolean checkshape=Standard_True)
| Creates a ShapeSet in order to build shapes connected by <SubShapeType> shapes. <checkshape>:check (or not) the shapes, startelements, elements added. More...
virtual void | Delete ()
virtual | ~TopOpeBRepBuild_ShapeSet ()
virtual void | AddShape (const TopoDS_Shape &S)
| Adds <S> to the list of shapes. (wires or shells). More...
virtual void | AddStartElement (const TopoDS_Shape &S)
| (S is a face or edge) Add S to the list of starting shapes used for reconstructions. apply AddElement(S). More...
virtual void | AddElement (const TopoDS_Shape &S)
| for each subshape SE of S of type mySubShapeType More...
const TopTools_ListOfShape & | StartElements () const
| return a reference on myStartShapes More...
void | InitShapes ()
Standard_Boolean | MoreShapes () const
void | NextShape ()
const TopoDS_Shape & | Shape () const
void | InitStartElements ()
Standard_Boolean | MoreStartElements () const
void | NextStartElement ()
const TopoDS_Shape & | StartElement () const
virtual void | InitNeighbours (const TopoDS_Shape &S)
Standard_Boolean | MoreNeighbours ()
void | NextNeighbour ()
const TopoDS_Shape & | Neighbour () const
TopTools_ListOfShape & | ChangeStartShapes ()
virtual void | FindNeighbours ()
| Build the list of neighbour shapes of myCurrentShape (neighbour shapes and myCurrentShapes are of type t) Initialize myIncidentShapesIter on neighbour shapes. More...
virtual const TopTools_ListOfShape & | MakeNeighboursList (const TopoDS_Shape &E, const TopoDS_Shape &V)
Standard_Integer | MaxNumberSubShape (const TopoDS_Shape &Shape)
void | CheckShape (const Standard_Boolean checkshape)
Standard_Boolean | CheckShape () const
Standard_Boolean | CheckShape (const TopoDS_Shape &S, const Standard_Boolean checkgeom=Standard_False)
void | DumpName (Standard_OStream &OS, const TCollection_AsciiString &str) const
void | DumpCheck (Standard_OStream &OS, const TCollection_AsciiString &str, const TopoDS_Shape &S, const Standard_Boolean chk) const
virtual void | DumpSS ()
virtual void | DumpBB ()
void | DEBName (const TCollection_AsciiString &N)
const TCollection_AsciiString & | DEBName () const
void | DEBNumber (const Standard_Integer I)
Standard_Integer | DEBNumber () const
virtual TCollection_AsciiString | SName (const TopoDS_Shape &S, const TCollection_AsciiString &sb="", const TCollection_AsciiString &sa="") const
virtual TCollection_AsciiString | SNameori (const TopoDS_Shape &S, const TCollection_AsciiString &sb="", const TCollection_AsciiString &sa="") const
virtual TCollection_AsciiString | SName (const TopTools_ListOfShape &S, const TCollection_AsciiString &sb="", const TCollection_AsciiString &sa="") const
virtual TCollection_AsciiString | SNameori (const TopTools_ListOfShape &S, const TCollection_AsciiString &sb="", const TCollection_AsciiString &sa="") const

## Protected Member Functions
void | ProcessAddShape (const TopoDS_Shape &S)
void | ProcessAddStartElement (const TopoDS_Shape &S)
void | ProcessAddElement (const TopoDS_Shape &S)

## Protected Attributes
TopAbs_ShapeEnum | myShapeType
TopAbs_ShapeEnum | mySubShapeType
TopOpeBRepTool_ShapeExplorer | mySubShapeExplorer
TopTools_ListOfShape | myStartShapes
TopTools_ListIteratorOfListOfShape | myStartShapesIter
TopTools_IndexedDataMapOfShapeListOfShape | mySubShapeMap
TopTools_ListIteratorOfListOfShape | myIncidentShapesIter
TopTools_ListOfShape | myShapes
TopTools_ListIteratorOfListOfShape | myShapesIter
TopoDS_Shape | myCurrentShape
TopTools_ListOfShape | myCurrentShapeNeighbours
Standard_Integer | myDEBNumber
TCollection_AsciiString | myDEBName
TopTools_IndexedMapOfOrientedShape | myOMSS
TopTools_IndexedMapOfOrientedShape | myOMES
TopTools_IndexedMapOfOrientedShape | myOMSH
Standard_Boolean | myCheckShape

## Detailed Description

Auxiliary class providing an exploration of a set of shapes to build faces or solids. To build faces : shapes are wires, elements are edges. To build solids : shapes are shells, elements are faces. The ShapeSet stores a list of shapes, a list of elements to start reconstructions, and a map to search neighbours. The map stores the connection between elements through subshapes of type <SubShapeType> given in constructor. <SubShapeType> is :

- TopAbs_VERTEX to connect edges
- TopAbs_EDGE to connect faces

Signature needed by the BlockBuilder : InitStartElements(me : in out) MoreStartElements(me) returns Boolean; NextStartElement(me : in out); StartElement(me) returns Shape; —C++: return const & InitNeighbours(me : in out; S : Shape); MoreNeighbours(me) returns Boolean; NextNeighbour(me : in out); Neighbour(me) returns Shape; —C++: return const &

## Constructor & Destructor Documentation

TopOpeBRepBuild_ShapeSet::TopOpeBRepBuild_ShapeSet | ( | const TopAbs_ShapeEnum | SubShapeType,
|  | const Standard_Boolean | checkshape = `Standard_True`
| ) |  |

Creates a ShapeSet in order to build shapes connected by <SubShapeType> shapes. <checkshape>:check (or not) the shapes, startelements, elements added.

virtual TopOpeBRepBuild_ShapeSet::~TopOpeBRepBuild_ShapeSet | ( |  | ) |
| inlinevirtual

## Member Function Documentation

virtual void TopOpeBRepBuild_ShapeSet::AddElement | ( | const TopoDS_Shape & | S | ) |
| virtual

for each subshape SE of S of type mySubShapeType

- Add subshapes of S to the map of subshapes (mySubShapeMap)
- Add S to the list of shape incident to subshapes of S.

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

virtual void TopOpeBRepBuild_ShapeSet::AddShape | ( | const TopoDS_Shape & | S | ) |
| virtual

Adds <S> to the list of shapes. (wires or shells).

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

virtual void TopOpeBRepBuild_ShapeSet::AddStartElement | ( | const TopoDS_Shape & | S | ) |
| virtual

(S is a face or edge) Add S to the list of starting shapes used for reconstructions. apply AddElement(S).

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

TopTools_ListOfShape& TopOpeBRepBuild_ShapeSet::ChangeStartShapes | ( |  | ) |

void TopOpeBRepBuild_ShapeSet::CheckShape | ( | const Standard_Boolean | checkshape | ) |

Standard_Boolean TopOpeBRepBuild_ShapeSet::CheckShape | ( |  | ) | const

Standard_Boolean TopOpeBRepBuild_ShapeSet::CheckShape | ( | const TopoDS_Shape & | S,
|  | const Standard_Boolean | checkgeom = `Standard_False`
| ) |  |

void TopOpeBRepBuild_ShapeSet::DEBName | ( | const TCollection_AsciiString & | N | ) |

const TCollection_AsciiString& TopOpeBRepBuild_ShapeSet::DEBName | ( |  | ) | const

void TopOpeBRepBuild_ShapeSet::DEBNumber | ( | const Standard_Integer | I | ) |

Standard_Integer TopOpeBRepBuild_ShapeSet::DEBNumber | ( |  | ) | const

virtual void TopOpeBRepBuild_ShapeSet::Delete | ( |  | ) |
| virtual

virtual void TopOpeBRepBuild_ShapeSet::DumpBB | ( |  | ) |
| virtual

void TopOpeBRepBuild_ShapeSet::DumpCheck | ( | Standard_OStream & | OS,
|  | const TCollection_AsciiString & | str,
|  | const TopoDS_Shape & | S,
|  | const Standard_Boolean | chk
| ) |  | const

void TopOpeBRepBuild_ShapeSet::DumpName | ( | Standard_OStream & | OS,
|  | const TCollection_AsciiString & | str
| ) |  | const

virtual void TopOpeBRepBuild_ShapeSet::DumpSS | ( |  | ) |
| virtual

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

virtual void TopOpeBRepBuild_ShapeSet::FindNeighbours | ( |  | ) |
| virtual

Build the list of neighbour shapes of myCurrentShape (neighbour shapes and myCurrentShapes are of type t) Initialize myIncidentShapesIter on neighbour shapes.

Reimplemented in TopOpeBRepBuild_WireEdgeSet.

virtual void TopOpeBRepBuild_ShapeSet::InitNeighbours | ( | const TopoDS_Shape & | S | ) |
| virtual

Reimplemented in TopOpeBRepBuild_WireEdgeSet.

void TopOpeBRepBuild_ShapeSet::InitShapes | ( |  | ) |

void TopOpeBRepBuild_ShapeSet::InitStartElements | ( |  | ) |

virtual const TopTools_ListOfShape& TopOpeBRepBuild_ShapeSet::MakeNeighboursList | ( | const TopoDS_Shape & | E,
|  | const TopoDS_Shape & | V
| ) |  |
| virtual

Reimplemented in TopOpeBRepBuild_WireEdgeSet.

Standard_Integer TopOpeBRepBuild_ShapeSet::MaxNumberSubShape | ( | const TopoDS_Shape & | Shape | ) |

Standard_Boolean TopOpeBRepBuild_ShapeSet::MoreNeighbours | ( |  | ) |

Standard_Boolean TopOpeBRepBuild_ShapeSet::MoreShapes | ( |  | ) | const

Standard_Boolean TopOpeBRepBuild_ShapeSet::MoreStartElements | ( |  | ) | const

const TopoDS_Shape& TopOpeBRepBuild_ShapeSet::Neighbour | ( |  | ) | const

void TopOpeBRepBuild_ShapeSet::NextNeighbour | ( |  | ) |

void TopOpeBRepBuild_ShapeSet::NextShape | ( |  | ) |

void TopOpeBRepBuild_ShapeSet::NextStartElement | ( |  | ) |

void TopOpeBRepBuild_ShapeSet::ProcessAddElement | ( | const TopoDS_Shape & | S | ) |
| protected

void TopOpeBRepBuild_ShapeSet::ProcessAddShape | ( | const TopoDS_Shape & | S | ) |
| protected

void TopOpeBRepBuild_ShapeSet::ProcessAddStartElement | ( | const TopoDS_Shape & | S | ) |
| protected

const TopoDS_Shape& TopOpeBRepBuild_ShapeSet::Shape | ( |  | ) | const

virtual TCollection_AsciiString TopOpeBRepBuild_ShapeSet::SName | ( | const TopoDS_Shape & | S,
|  | const TCollection_AsciiString & | sb = `""`,
|  | const TCollection_AsciiString & | sa = `""`
| ) |  | const
| virtual

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

virtual TCollection_AsciiString TopOpeBRepBuild_ShapeSet::SName | ( | const TopTools_ListOfShape & | S,
|  | const TCollection_AsciiString & | sb = `""`,
|  | const TCollection_AsciiString & | sa = `""`
| ) |  | const
| virtual

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

virtual TCollection_AsciiString TopOpeBRepBuild_ShapeSet::SNameori | ( | const TopoDS_Shape & | S,
|  | const TCollection_AsciiString & | sb = `""`,
|  | const TCollection_AsciiString & | sa = `""`
| ) |  | const
| virtual

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

virtual TCollection_AsciiString TopOpeBRepBuild_ShapeSet::SNameori | ( | const TopTools_ListOfShape & | S,
|  | const TCollection_AsciiString & | sb = `""`,
|  | const TCollection_AsciiString & | sa = `""`
| ) |  | const
| virtual

Reimplemented in TopOpeBRepBuild_WireEdgeSet, and TopOpeBRepBuild_ShellFaceSet.

const TopoDS_Shape& TopOpeBRepBuild_ShapeSet::StartElement | ( |  | ) | const

const TopTools_ListOfShape& TopOpeBRepBuild_ShapeSet::StartElements | ( |  | ) | const

return a reference on myStartShapes

## Field Documentation

Standard_Boolean TopOpeBRepBuild_ShapeSet::myCheckShape
| protected

TopoDS_Shape TopOpeBRepBuild_ShapeSet::myCurrentShape
| protected

TopTools_ListOfShape TopOpeBRepBuild_ShapeSet::myCurrentShapeNeighbours
| protected

TCollection_AsciiString TopOpeBRepBuild_ShapeSet::myDEBName
| protected

Standard_Integer TopOpeBRepBuild_ShapeSet::myDEBNumber
| protected

TopTools_ListIteratorOfListOfShape TopOpeBRepBuild_ShapeSet::myIncidentShapesIter
| protected

TopTools_IndexedMapOfOrientedShape TopOpeBRepBuild_ShapeSet::myOMES
| protected

TopTools_IndexedMapOfOrientedShape TopOpeBRepBuild_ShapeSet::myOMSH
| protected

TopTools_IndexedMapOfOrientedShape TopOpeBRepBuild_ShapeSet::myOMSS
| protected

TopTools_ListOfShape TopOpeBRepBuild_ShapeSet::myShapes
| protected

TopTools_ListIteratorOfListOfShape TopOpeBRepBuild_ShapeSet::myShapesIter
| protected

TopAbs_ShapeEnum TopOpeBRepBuild_ShapeSet::myShapeType
| protected

TopTools_ListOfShape TopOpeBRepBuild_ShapeSet::myStartShapes
| protected

TopTools_ListIteratorOfListOfShape TopOpeBRepBuild_ShapeSet::myStartShapesIter
| protected

TopOpeBRepTool_ShapeExplorer TopOpeBRepBuild_ShapeSet::mySubShapeExplorer
| protected

TopTools_IndexedDataMapOfShapeListOfShape TopOpeBRepBuild_ShapeSet::mySubShapeMap
| protected

TopAbs_ShapeEnum TopOpeBRepBuild_ShapeSet::mySubShapeType
| protected

The documentation for this class was generated from the following file:

- TopOpeBRepBuild_ShapeSet.hxx